// CompMD5.h: interface for the CCompMD5 class.
//
//////////////////////////////////////////////////////////////////////


// Required stuff for using MD5

/*
 * Copyright  1991-2, RSA Data Security, Inc. Created 1991. All
 * rights reserved.
 *
 * License to copy and use this software is granted provided that it
 * is identified as the "RSA Data Security, Inc. MD5 Message-Digest
 * Algorithm" in all material mentioning or referencing this software
 * or this function.
 *
 * License is also granted to make and use derivative works provided
 * that such works are identified as "derived from the RSA Data
 * Security, Inc. MD5 Message-Digest Algorithm" in all material
 * mentioning or referencing the derived work.
 *
 * RSA Data Security, Inc. makes no representations concerning either
 * the merchantability of this software or the suitability of this
 * software for any particular purpose. It is provided "as is"
 * without express or implied warranty of any kind.
 * These notices must be retained in any copies of any part of this
 * documentation and/or software.
 */

#if !defined(AFX_COMPMD5_H__B9149E29_9392_4598_B82A_E4EDB9B16055__INCLUDED_)
#define AFX_COMPMD5_H__B9149E29_9392_4598_B82A_E4EDB9B16055__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


typedef unsigned short UINT2;
typedef unsigned long UINT4;

/* MD5 context. */

typedef struct {
	UINT4 state[4];           /* state (ABCD) */
	UINT4 count[2];           /* number of bits, modulo 2^64 (lsb first) */
	unsigned char buffer[64]; /* input buffer */
} MD5_CTX; 



class CCompMD5  
{
public:
	CCompMD5();
	virtual ~CCompMD5();

	BOOL MD5_sum_file(CString filename,unsigned char digest[16]);


private:
	void MD5Init(MD5_CTX *context);
	void MD5Update(MD5_CTX *context, unsigned char *input, unsigned int inputLen);
	void MD5Final(unsigned char *digest, MD5_CTX *context);
	void MD5Transform (UINT4 state[4], unsigned char block[64]);
	void Encode(unsigned char *output, UINT4 *input, unsigned int len);

	unsigned char md5buffer[8192];
};

#endif // !defined(AFX_COMPMD5_H__B9149E29_9392_4598_B82A_E4EDB9B16055__INCLUDED_)
